Wurde der Kunde z. B. von eBay importiert, ist das die eindeutige Kennung aus der Quelle
String
""
external_account_name
Wurde der Kunde z. B. von eBay importiert, ist das der Name des eBay-Kontos
String
""
customer_type
Quelle des Kunden, z. B. "amazon". "csv" für den CSV-Import, das Programm, aus dem die Datei stammt, steht in external_account_name, z. B. "Billbee"
String
"billware"
customer_nr
Kundennummer; ist sie leer oder nicht gesetzt, wird eine Kundennummer erzeugt
String
Generated Number
is_business_client
Gibt an, ob der Kunde ein Geschäftskunde ist
0 Nein1 Ja
0
bill_title
Anrede des Kunden
-1 Firma0 Herr1 Frau2 Divers3 Keine Anrede4 Familie5 Eheleute6 Doktor7 Professor
-1
bill_firstname
Vorname
String
""
bill_lastname
Nachname
String
""
bill_company
Firmenname
String
""
bill_vat_nr
Umsatzsteuer-Identifikationsnummer des Kunden
String
""
bill_street
Straße
String
""
bill_street2
Adresszusatz
String
""
bill_zipcode
Postleitzahl
String
""
bill_city
Ort
String
""
bill_country
Ländercode (ISO 3166 ALPHA-2) in Kleinbuchstaben, z. B. de; Großschreibung wird klein gespeichert
String
""
bill_phone
Telefonnummer
String
""
bill_phone_mobile
Mobilnummer
String
""
bill_email
E-Mail-Adresse
String
""
divergent_delivery_address
Gibt an, ob für diesen Kunden eine Lieferadresse angelegt werden soll
0 Nein1 Ja
0
delivery_title
Lieferadresse: Anrede des Kunden
-1 Firma0 Herr1 Frau2 Divers3 Keine Anrede4 Familie5 Eheleute6 Doktor7 Professor
-1
delivery_firstname
Lieferadresse: Vorname
String
""
delivery_lastname
Lieferadresse: Nachname
String
""
delivery_company
Lieferadresse: Firmenname
String
""
delivery_street
Lieferadresse: Straße
String
""
delivery_street2
Lieferadresse: Adresszusatz
String
""
delivery_zipcode
Lieferadresse: Postleitzahl
String
""
delivery_city
Lieferadresse: Ort
String
""
delivery_country
Lieferadresse: Ländercode (ISO 3166 ALPHA-2) in Kleinbuchstaben, z. B. de; Großschreibung wird klein gespeichert
String
"de"
delivery_phone
Lieferadresse: Telefonnummer
String
""
delivery_phone_mobile
Lieferadresse: Mobilnummer
String
""
account_bank
Name der Bank
String
""
account_bic
BIC der Bank
String
""
account_iban
IBAN des Kundenkontos
String
""
account_paypal
PayPal-Konto des Kunden
String
""
term_of_credit
Zahlungsziel in Tagen
Integer
Das Zahlungsziel aus deinen billware-Einstellungen
user_note
Optionale interne Notiz zu diesem Kunden
String
""
public_authority_id
Leitweg-ID einer Behörde, z. B. 04011000-1234512345-06. Neue Aufträge des Kunden übernehmen sie. Die Prüfziffern werden geprüft, eine falsche ID wird abgelehnt. Eine Änderung erreicht auch die Aufträge des Kunden ohne Rechnungsnummer, die noch die bisherige Leitweg-ID tragen
String bis 46 Zeichen
""
Codebeispiele
# Get your API credentials from your billware customer area
API_APPID="your-app-id"
API_SECRET="your-api-secret"
PAYLOAD='{"customer_type":"billware","is_business_client":0,"bill_title":"Mister","bill_firstname":"Max","bill_lastname":"Mustermann","bill_street":"Musterstraße 12","bill_zipcode":"12345","bill_city":"Musterstadt","bill_country":"de","bill_phone":"+49 123 4567890","bill_email":"max.mustermann@example.com","divergent_delivery_address":1,"delivery_title":"Mister","delivery_firstname":"Max","delivery_lastname":"Mustermann","delivery_street":"Lieferweg 5","delivery_zipcode":"54321","delivery_city":"Lieferstadt","delivery_country":"de","delivery_phone":"+49 987 6543210","account_iban":"DE89370400440532013000","account_bic":"COBADEFFXXX","account_bank":"Commerzbank","account_paypal":"max.paypal@example.com","user_note":"Kunde möchte Rechnung nur per E-Mail erhalten","public_authority_id":""}'
# The HMAC is calculated over the exact request body that is sent
HMAC=$(printf '%s' "$PAYLOAD" | openssl dgst -sha256 -hmac "$API_SECRET" -binary | base64)
curl -X POST "https://www.billware.de/api/v1" \
-H "X-Bw-Hmac: $API_APPID:$HMAC" \
-H "X-Bw-Method: customer.create" \
-H "Content-Type: application/json" \
-d "$PAYLOAD"
import crypto from 'node:crypto';
// Get your API credentials from your billware customer area
const apiAppId = 'your-app-id';
const apiSecret = 'your-api-secret';
const payload = JSON.stringify({
"customer_type": "billware",
"is_business_client": 0,
"bill_title": "Mister",
"bill_firstname": "Max",
"bill_lastname": "Mustermann",
"bill_street": "Musterstraße 12",
"bill_zipcode": "12345",
"bill_city": "Musterstadt",
"bill_country": "de",
"bill_phone": "+49 123 4567890",
"bill_email": "max.mustermann@example.com",
"divergent_delivery_address": 1,
"delivery_title": "Mister",
"delivery_firstname": "Max",
"delivery_lastname": "Mustermann",
"delivery_street": "Lieferweg 5",
"delivery_zipcode": "54321",
"delivery_city": "Lieferstadt",
"delivery_country": "de",
"delivery_phone": "+49 987 6543210",
"account_iban": "DE89370400440532013000",
"account_bic": "COBADEFFXXX",
"account_bank": "Commerzbank",
"account_paypal": "max.paypal@example.com",
"user_note": "Kunde möchte Rechnung nur per E-Mail erhalten",
"public_authority_id": ""
});
// The HMAC is calculated over the exact request body that is sent
const hmac = crypto.createHmac('sha256', apiSecret).update(payload).digest('base64');
const response = await fetch('https://www.billware.de/api/v1', {
method: 'POST',
headers: {
'X-Bw-Hmac': `${apiAppId}:${hmac}`,
'X-Bw-Method': 'customer.create',
'Content-Type': 'application/json'
},
body: payload
});
console.log(await response.json());
import base64
import hashlib
import hmac
import json
import requests
# Get your API credentials from your billware customer area
api_appid = "your-app-id"
api_secret = "your-api-secret"
payload = json.dumps({
"customer_type": "billware",
"is_business_client": 0,
"bill_title": "Mister",
"bill_firstname": "Max",
"bill_lastname": "Mustermann",
"bill_street": "Musterstraße 12",
"bill_zipcode": "12345",
"bill_city": "Musterstadt",
"bill_country": "de",
"bill_phone": "+49 123 4567890",
"bill_email": "max.mustermann@example.com",
"divergent_delivery_address": 1,
"delivery_title": "Mister",
"delivery_firstname": "Max",
"delivery_lastname": "Mustermann",
"delivery_street": "Lieferweg 5",
"delivery_zipcode": "54321",
"delivery_city": "Lieferstadt",
"delivery_country": "de",
"delivery_phone": "+49 987 6543210",
"account_iban": "DE89370400440532013000",
"account_bic": "COBADEFFXXX",
"account_bank": "Commerzbank",
"account_paypal": "max.paypal@example.com",
"user_note": "Kunde möchte Rechnung nur per E-Mail erhalten",
"public_authority_id": "",
})
# The HMAC is calculated over the exact request body that is sent
signature = base64.b64encode(
hmac.new(api_secret.encode(), payload.encode(), hashlib.sha256).digest()
).decode()
response = requests.post(
"https://www.billware.de/api/v1",
data=payload,
headers={
"X-Bw-Hmac": f"{api_appid}:{signature}",
"X-Bw-Method": "customer.create",
"Content-Type": "application/json",
},
)
print(response.json())
using System.Net.Http;
using System.Security.Cryptography;
using System.Text;
using System.Text.Json;
// Get your API credentials from your billware customer area
const string apiAppId = "your-app-id";
const string apiSecret = "your-api-secret";
var payload = JsonSerializer.Serialize(new
{
customer_type = "billware",
is_business_client = 0,
bill_title = "Mister",
bill_firstname = "Max",
bill_lastname = "Mustermann",
bill_street = "Musterstraße 12",
bill_zipcode = "12345",
bill_city = "Musterstadt",
bill_country = "de",
bill_phone = "+49 123 4567890",
bill_email = "max.mustermann@example.com",
divergent_delivery_address = 1,
delivery_title = "Mister",
delivery_firstname = "Max",
delivery_lastname = "Mustermann",
delivery_street = "Lieferweg 5",
delivery_zipcode = "54321",
delivery_city = "Lieferstadt",
delivery_country = "de",
delivery_phone = "+49 987 6543210",
account_iban = "DE89370400440532013000",
account_bic = "COBADEFFXXX",
account_bank = "Commerzbank",
account_paypal = "max.paypal@example.com",
user_note = "Kunde möchte Rechnung nur per E-Mail erhalten",
public_authority_id = ""
});
// The HMAC is calculated over the exact request body that is sent
using var hmac = new HMACSHA256(Encoding.UTF8.GetBytes(apiSecret));
var signature = Convert.ToBase64String(hmac.ComputeHash(Encoding.UTF8.GetBytes(payload)));
using var client = new HttpClient();
var request = new HttpRequestMessage(HttpMethod.Post, "https://www.billware.de/api/v1")
{
Content = new StringContent(payload, Encoding.UTF8, "application/json")
};
request.Headers.Add("X-Bw-Hmac", $"{apiAppId}:{signature}");
request.Headers.Add("X-Bw-Method", "customer.create");
var response = await client.SendAsync(request);
Console.WriteLine(await response.Content.ReadAsStringAsync());
Rückgabewerte
Felder
Beschreibung
customer_ident
Kennung des angelegten Kunden
address_ident
Kennung der angelegten Lieferadresse. Steht divergent_delivery_address auf 0, ist der Wert NULL
Beispielantworten
// SUCCESS creating a customer with a delivery address
{
"response":true,
"data":{
"customer_ident":"30818cqJ36X624SC",
"address_ident":"61636lu6Et7324W8"
},
"method":"customer.create",
"message":"customer created"
}
customer.read
Liefert die Daten eines Kunden.
Daten
Felder
Beschreibung
Erlaubte Werte
customer_ident Pflicht
Kennung des Kunden
String
Codebeispiele
# Get your API credentials from your billware customer area
API_APPID="your-app-id"
API_SECRET="your-api-secret"
PAYLOAD='{"customer_ident":"46yq1898qmohrz57"}'
# The HMAC is calculated over the exact request body that is sent
HMAC=$(printf '%s' "$PAYLOAD" | openssl dgst -sha256 -hmac "$API_SECRET" -binary | base64)
curl -X POST "https://www.billware.de/api/v1" \
-H "X-Bw-Hmac: $API_APPID:$HMAC" \
-H "X-Bw-Method: customer.read" \
-H "Content-Type: application/json" \
-d "$PAYLOAD"
<?php
// Get your API credentials from your billware customer area
$apiAppId = 'your-app-id';
$apiSecret = 'your-api-secret';
$payload = json_encode([
'customer_ident' => '46yq1898qmohrz57',
]);
// The HMAC is calculated over the exact request body that is sent
$hmac = base64_encode(hash_hmac('sha256', $payload, $apiSecret, true));
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => 'https://www.billware.de/api/v1',
CURLOPT_POST => true,
CURLOPT_POSTFIELDS => $payload,
CURLOPT_RETURNTRANSFER => true,
CURLOPT_HTTPHEADER => [
'X-Bw-Hmac: '.$apiAppId.':'.$hmac,
'X-Bw-Method: customer.read',
'Content-Type: application/json',
],
]);
$response = curl_exec($curl);
curl_close($curl);
print_r(json_decode($response, true));
import crypto from 'node:crypto';
// Get your API credentials from your billware customer area
const apiAppId = 'your-app-id';
const apiSecret = 'your-api-secret';
const payload = JSON.stringify({
"customer_ident": "46yq1898qmohrz57"
});
// The HMAC is calculated over the exact request body that is sent
const hmac = crypto.createHmac('sha256', apiSecret).update(payload).digest('base64');
const response = await fetch('https://www.billware.de/api/v1', {
method: 'POST',
headers: {
'X-Bw-Hmac': `${apiAppId}:${hmac}`,
'X-Bw-Method': 'customer.read',
'Content-Type': 'application/json'
},
body: payload
});
console.log(await response.json());
import base64
import hashlib
import hmac
import json
import requests
# Get your API credentials from your billware customer area
api_appid = "your-app-id"
api_secret = "your-api-secret"
payload = json.dumps({
"customer_ident": "46yq1898qmohrz57",
})
# The HMAC is calculated over the exact request body that is sent
signature = base64.b64encode(
hmac.new(api_secret.encode(), payload.encode(), hashlib.sha256).digest()
).decode()
response = requests.post(
"https://www.billware.de/api/v1",
data=payload,
headers={
"X-Bw-Hmac": f"{api_appid}:{signature}",
"X-Bw-Method": "customer.read",
"Content-Type": "application/json",
},
)
print(response.json())
using System.Net.Http;
using System.Security.Cryptography;
using System.Text;
using System.Text.Json;
// Get your API credentials from your billware customer area
const string apiAppId = "your-app-id";
const string apiSecret = "your-api-secret";
var payload = JsonSerializer.Serialize(new
{
customer_ident = "46yq1898qmohrz57"
});
// The HMAC is calculated over the exact request body that is sent
using var hmac = new HMACSHA256(Encoding.UTF8.GetBytes(apiSecret));
var signature = Convert.ToBase64String(hmac.ComputeHash(Encoding.UTF8.GetBytes(payload)));
using var client = new HttpClient();
var request = new HttpRequestMessage(HttpMethod.Post, "https://www.billware.de/api/v1")
{
Content = new StringContent(payload, Encoding.UTF8, "application/json")
};
request.Headers.Add("X-Bw-Hmac", $"{apiAppId}:{signature}");
request.Headers.Add("X-Bw-Method", "customer.read");
var response = await client.SendAsync(request);
Console.WriteLine(await response.Content.ReadAsStringAsync());
Rückgabewerte
Felder
Beschreibung
Typ
customer_ident
Kennung des Kunden
String
external_ident
Wurde der Kunde z. B. von eBay importiert, ist das die eindeutige Kennung aus der Quelle
String
external_account_name
Wurde der Kunde z. B. von eBay importiert, ist das der Name des eBay-Kontos
String
external_username
Wurde der Kunde z. B. von eBay importiert, ist das der Benutzername des Kunden
String
date_created
Datum und Uhrzeit, wann der Kunde angelegt wurde
Datum als String
date_created_user
Datum, wann der Kunde angelegt wurde, im Format des Kontos, z. B. "19.10.2018"
Datum als String
date_updated
Datum und Uhrzeit der letzten Änderung des Kunden
Datum als String
date_updated_user
Datum der letzten Änderung des Kunden im Format des Kontos, z. B. "19.10.2018"
Datum als String
customer_type
Quelle des Kunden, z. B. "amazon"
String
customer_nr
Die Kundennummer
String
is_business_client
Gibt an, ob der Kunde ein Geschäftskunde ist
0 Nein1 Ja
bill_title
Anrede des Kunden
-1 Firma0 Herr1 Frau2 Divers3 Keine Anrede4 Familie5 Eheleute6 Doktor7 Professor
bill_firstname
Vorname
String
bill_lastname
Nachname
String
bill_company
Firmenname
String
bill_vat_nr
Umsatzsteuer-Identifikationsnummer
String
bill_street
Straße
String
bill_street2
Adresszusatz
String
bill_zipcode
Postleitzahl
String
bill_city
Ort
String
bill_country
Ländercode (ISO 3166 ALPHA-2) in Kleinbuchstaben, z. B. de; Großschreibung wird klein gespeichert
String
bill_email
E-Mail-Adresse
String
bill_phone
Telefonnummer
String
bill_phone_mobile
Mobilnummer
String
account_bank
Name der Bank
String
account_bic
BIC der Bank
String
account_iban
IBAN des Kundenkontos
String
account_paypal
PayPal-Konto des Kunden
String
term_of_credit
Zahlungsziel in Tagen
Integer
user_note
Interne Notiz zu diesem Kunden
String
public_authority_id
Leitweg-ID einer Behörde, leer, wenn keine gesetzt ist
String
address_data
Array mit den Adressen des Kunden
Array
[KEYS]
Array-Element mit den Feldern einer Adresse
Array Key
address_ident
Kennung der Adresse
String
customer_ident
Kennung des Kunden, dem diese Adresse gehört
String
delivery_title
Anrede des Kunden
-1 Firma0 Herr1 Frau2 Divers3 Keine Anrede4 Familie5 Eheleute6 Doktor7 Professor
delivery_firstname
Vorname
String
delivery_lastname
Nachname
String
delivery_company
Firmenname
String
delivery_street
Straße
String
delivery_street2
Adresszusatz
String
delivery_zipcode
Postleitzahl
String
delivery_city
Ort
String
delivery_country
Ländercode (ISO 3166 ALPHA-2) in Kleinbuchstaben, z. B. de; Großschreibung wird klein gespeichert
# Get your API credentials from your billware customer area
API_APPID="your-app-id"
API_SECRET="your-api-secret"
PAYLOAD='{"customer_ident":"46yq1898qmohrz57","bill_firstname":"Moritz"}'
# The HMAC is calculated over the exact request body that is sent
HMAC=$(printf '%s' "$PAYLOAD" | openssl dgst -sha256 -hmac "$API_SECRET" -binary | base64)
curl -X POST "https://www.billware.de/api/v1" \
-H "X-Bw-Hmac: $API_APPID:$HMAC" \
-H "X-Bw-Method: customer.update" \
-H "Content-Type: application/json" \
-d "$PAYLOAD"
<?php
// Get your API credentials from your billware customer area
$apiAppId = 'your-app-id';
$apiSecret = 'your-api-secret';
$payload = json_encode([
'customer_ident' => '46yq1898qmohrz57',
'bill_firstname' => 'Moritz',
]);
// The HMAC is calculated over the exact request body that is sent
$hmac = base64_encode(hash_hmac('sha256', $payload, $apiSecret, true));
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => 'https://www.billware.de/api/v1',
CURLOPT_POST => true,
CURLOPT_POSTFIELDS => $payload,
CURLOPT_RETURNTRANSFER => true,
CURLOPT_HTTPHEADER => [
'X-Bw-Hmac: '.$apiAppId.':'.$hmac,
'X-Bw-Method: customer.update',
'Content-Type: application/json',
],
]);
$response = curl_exec($curl);
curl_close($curl);
print_r(json_decode($response, true));
import crypto from 'node:crypto';
// Get your API credentials from your billware customer area
const apiAppId = 'your-app-id';
const apiSecret = 'your-api-secret';
const payload = JSON.stringify({
"customer_ident": "46yq1898qmohrz57",
"bill_firstname": "Moritz"
});
// The HMAC is calculated over the exact request body that is sent
const hmac = crypto.createHmac('sha256', apiSecret).update(payload).digest('base64');
const response = await fetch('https://www.billware.de/api/v1', {
method: 'POST',
headers: {
'X-Bw-Hmac': `${apiAppId}:${hmac}`,
'X-Bw-Method': 'customer.update',
'Content-Type': 'application/json'
},
body: payload
});
console.log(await response.json());
import base64
import hashlib
import hmac
import json
import requests
# Get your API credentials from your billware customer area
api_appid = "your-app-id"
api_secret = "your-api-secret"
payload = json.dumps({
"customer_ident": "46yq1898qmohrz57",
"bill_firstname": "Moritz",
})
# The HMAC is calculated over the exact request body that is sent
signature = base64.b64encode(
hmac.new(api_secret.encode(), payload.encode(), hashlib.sha256).digest()
).decode()
response = requests.post(
"https://www.billware.de/api/v1",
data=payload,
headers={
"X-Bw-Hmac": f"{api_appid}:{signature}",
"X-Bw-Method": "customer.update",
"Content-Type": "application/json",
},
)
print(response.json())
using System.Net.Http;
using System.Security.Cryptography;
using System.Text;
using System.Text.Json;
// Get your API credentials from your billware customer area
const string apiAppId = "your-app-id";
const string apiSecret = "your-api-secret";
var payload = JsonSerializer.Serialize(new
{
customer_ident = "46yq1898qmohrz57",
bill_firstname = "Moritz"
});
// The HMAC is calculated over the exact request body that is sent
using var hmac = new HMACSHA256(Encoding.UTF8.GetBytes(apiSecret));
var signature = Convert.ToBase64String(hmac.ComputeHash(Encoding.UTF8.GetBytes(payload)));
using var client = new HttpClient();
var request = new HttpRequestMessage(HttpMethod.Post, "https://www.billware.de/api/v1")
{
Content = new StringContent(payload, Encoding.UTF8, "application/json")
};
request.Headers.Add("X-Bw-Hmac", $"{apiAppId}:{signature}");
request.Headers.Add("X-Bw-Method", "customer.update");
var response = await client.SendAsync(request);
Console.WriteLine(await response.Content.ReadAsStringAsync());
Antwortdaten
Felder
Beschreibung
Typ
response
Gibt an, ob die Aktion erfolgreich war
truefalse
data
Array mit den Antwortdaten
Array
customer_ident
Die Kennung des geänderten Kunden
String
[fields]
Alle geänderten und bereinigten Felder
method
customer.update
String
message
Zusätzliche Information zur Anfrage
String
Beispielantworten
// SUCCESS after updating the customer term of credit
{
"response":true,
"data": {
"customer_ident" : "30Wp80787u99z2qv",
"term_of_credit" : "20"
},
"method":"customer.update",
"message":"customer updated"
}
// ERROR
{
"response":false,
"data": null,
"method":"customer.update",
"message":"customer not found"
}
customer.delete
Löscht einen bestehenden Kunden.
Daten
Felder
Beschreibung
Erlaubte Werte
customer_ident Pflicht
Kennung des Kunden
String
Codebeispiele
# Get your API credentials from your billware customer area
API_APPID="your-app-id"
API_SECRET="your-api-secret"
PAYLOAD='{"customer_ident":"46yq1898qmohrz57"}'
# The HMAC is calculated over the exact request body that is sent
HMAC=$(printf '%s' "$PAYLOAD" | openssl dgst -sha256 -hmac "$API_SECRET" -binary | base64)
curl -X POST "https://www.billware.de/api/v1" \
-H "X-Bw-Hmac: $API_APPID:$HMAC" \
-H "X-Bw-Method: customer.delete" \
-H "Content-Type: application/json" \
-d "$PAYLOAD"
<?php
// Get your API credentials from your billware customer area
$apiAppId = 'your-app-id';
$apiSecret = 'your-api-secret';
$payload = json_encode([
'customer_ident' => '46yq1898qmohrz57',
]);
// The HMAC is calculated over the exact request body that is sent
$hmac = base64_encode(hash_hmac('sha256', $payload, $apiSecret, true));
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => 'https://www.billware.de/api/v1',
CURLOPT_POST => true,
CURLOPT_POSTFIELDS => $payload,
CURLOPT_RETURNTRANSFER => true,
CURLOPT_HTTPHEADER => [
'X-Bw-Hmac: '.$apiAppId.':'.$hmac,
'X-Bw-Method: customer.delete',
'Content-Type: application/json',
],
]);
$response = curl_exec($curl);
curl_close($curl);
print_r(json_decode($response, true));
import crypto from 'node:crypto';
// Get your API credentials from your billware customer area
const apiAppId = 'your-app-id';
const apiSecret = 'your-api-secret';
const payload = JSON.stringify({
"customer_ident": "46yq1898qmohrz57"
});
// The HMAC is calculated over the exact request body that is sent
const hmac = crypto.createHmac('sha256', apiSecret).update(payload).digest('base64');
const response = await fetch('https://www.billware.de/api/v1', {
method: 'POST',
headers: {
'X-Bw-Hmac': `${apiAppId}:${hmac}`,
'X-Bw-Method': 'customer.delete',
'Content-Type': 'application/json'
},
body: payload
});
console.log(await response.json());
import base64
import hashlib
import hmac
import json
import requests
# Get your API credentials from your billware customer area
api_appid = "your-app-id"
api_secret = "your-api-secret"
payload = json.dumps({
"customer_ident": "46yq1898qmohrz57",
})
# The HMAC is calculated over the exact request body that is sent
signature = base64.b64encode(
hmac.new(api_secret.encode(), payload.encode(), hashlib.sha256).digest()
).decode()
response = requests.post(
"https://www.billware.de/api/v1",
data=payload,
headers={
"X-Bw-Hmac": f"{api_appid}:{signature}",
"X-Bw-Method": "customer.delete",
"Content-Type": "application/json",
},
)
print(response.json())
using System.Net.Http;
using System.Security.Cryptography;
using System.Text;
using System.Text.Json;
// Get your API credentials from your billware customer area
const string apiAppId = "your-app-id";
const string apiSecret = "your-api-secret";
var payload = JsonSerializer.Serialize(new
{
customer_ident = "46yq1898qmohrz57"
});
// The HMAC is calculated over the exact request body that is sent
using var hmac = new HMACSHA256(Encoding.UTF8.GetBytes(apiSecret));
var signature = Convert.ToBase64String(hmac.ComputeHash(Encoding.UTF8.GetBytes(payload)));
using var client = new HttpClient();
var request = new HttpRequestMessage(HttpMethod.Post, "https://www.billware.de/api/v1")
{
Content = new StringContent(payload, Encoding.UTF8, "application/json")
};
request.Headers.Add("X-Bw-Hmac", $"{apiAppId}:{signature}");
request.Headers.Add("X-Bw-Method", "customer.delete");
var response = await client.SendAsync(request);
Console.WriteLine(await response.Content.ReadAsStringAsync());
# Get your API credentials from your billware customer area
API_APPID="your-app-id"
API_SECRET="your-api-secret"
PAYLOAD='{"customer_ident":"46yq1898qmohrz57"}'
# The HMAC is calculated over the exact request body that is sent
HMAC=$(printf '%s' "$PAYLOAD" | openssl dgst -sha256 -hmac "$API_SECRET" -binary | base64)
curl -X POST "https://www.billware.de/api/v1" \
-H "X-Bw-Hmac: $API_APPID:$HMAC" \
-H "X-Bw-Method: customer.exists" \
-H "Content-Type: application/json" \
-d "$PAYLOAD"
<?php
// Get your API credentials from your billware customer area
$apiAppId = 'your-app-id';
$apiSecret = 'your-api-secret';
$payload = json_encode([
'customer_ident' => '46yq1898qmohrz57',
]);
// The HMAC is calculated over the exact request body that is sent
$hmac = base64_encode(hash_hmac('sha256', $payload, $apiSecret, true));
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => 'https://www.billware.de/api/v1',
CURLOPT_POST => true,
CURLOPT_POSTFIELDS => $payload,
CURLOPT_RETURNTRANSFER => true,
CURLOPT_HTTPHEADER => [
'X-Bw-Hmac: '.$apiAppId.':'.$hmac,
'X-Bw-Method: customer.exists',
'Content-Type: application/json',
],
]);
$response = curl_exec($curl);
curl_close($curl);
print_r(json_decode($response, true));
import crypto from 'node:crypto';
// Get your API credentials from your billware customer area
const apiAppId = 'your-app-id';
const apiSecret = 'your-api-secret';
const payload = JSON.stringify({
"customer_ident": "46yq1898qmohrz57"
});
// The HMAC is calculated over the exact request body that is sent
const hmac = crypto.createHmac('sha256', apiSecret).update(payload).digest('base64');
const response = await fetch('https://www.billware.de/api/v1', {
method: 'POST',
headers: {
'X-Bw-Hmac': `${apiAppId}:${hmac}`,
'X-Bw-Method': 'customer.exists',
'Content-Type': 'application/json'
},
body: payload
});
console.log(await response.json());
import base64
import hashlib
import hmac
import json
import requests
# Get your API credentials from your billware customer area
api_appid = "your-app-id"
api_secret = "your-api-secret"
payload = json.dumps({
"customer_ident": "46yq1898qmohrz57",
})
# The HMAC is calculated over the exact request body that is sent
signature = base64.b64encode(
hmac.new(api_secret.encode(), payload.encode(), hashlib.sha256).digest()
).decode()
response = requests.post(
"https://www.billware.de/api/v1",
data=payload,
headers={
"X-Bw-Hmac": f"{api_appid}:{signature}",
"X-Bw-Method": "customer.exists",
"Content-Type": "application/json",
},
)
print(response.json())
using System.Net.Http;
using System.Security.Cryptography;
using System.Text;
using System.Text.Json;
// Get your API credentials from your billware customer area
const string apiAppId = "your-app-id";
const string apiSecret = "your-api-secret";
var payload = JsonSerializer.Serialize(new
{
customer_ident = "46yq1898qmohrz57"
});
// The HMAC is calculated over the exact request body that is sent
using var hmac = new HMACSHA256(Encoding.UTF8.GetBytes(apiSecret));
var signature = Convert.ToBase64String(hmac.ComputeHash(Encoding.UTF8.GetBytes(payload)));
using var client = new HttpClient();
var request = new HttpRequestMessage(HttpMethod.Post, "https://www.billware.de/api/v1")
{
Content = new StringContent(payload, Encoding.UTF8, "application/json")
};
request.Headers.Add("X-Bw-Hmac", $"{apiAppId}:{signature}");
request.Headers.Add("X-Bw-Method", "customer.exists");
var response = await client.SendAsync(request);
Console.WriteLine(await response.Content.ReadAsStringAsync());
Beispielantworten
// SUCCESS
{
"response":true,
"data": {
"customer_ident" : "30Wp80787u99z2qv"
},
"method":"customer.exists",
"message":"customer does exist"
}
// ERROR
{
"response":false,
"data": null,
"method":"customer.exists",
"message":"customer does not exist"
}
address.create
Legt eine neue Lieferadresse für einen Kunden an.
Daten
Felder
Beschreibung
Erlaubte Werte
Standard
customer_ident Pflicht
Kennung des Kunden
String
delivery_title
Anrede des Kunden
-1 Firma0 Herr1 Frau2 Divers3 Keine Anrede4 Familie5 Eheleute6 Doktor7 Professor
-1
delivery_firstname
Vorname
String
""
delivery_lastname
Nachname
String
""
delivery_company
Firmenname
String
""
delivery_street
Straße
String
""
delivery_street2
Adresszusatz
String
""
delivery_zipcode
Postleitzahl
String
""
delivery_city
Ort
String
""
delivery_country
Ländercode (ISO 3166 ALPHA-2) in Kleinbuchstaben, z. B. de; Großschreibung wird klein gespeichert
String
"de"
delivery_phone
Telefonnummer
String
""
delivery_phone_mobile
Mobilnummer
String
""
Codebeispiele
# Get your API credentials from your billware customer area
API_APPID="your-app-id"
API_SECRET="your-api-secret"
PAYLOAD='{"customer_ident":"46yq1898qmohrz57","delivery_title":0,"delivery_firstname":"Max","delivery_lastname":"Mustermann","delivery_company":"Muster GmbH","delivery_street":"Lieferweg 5","delivery_street2":"Etage 3","delivery_zipcode":"54321","delivery_city":"Lieferstadt","delivery_country":"de","delivery_phone":"+49 987 6543210","delivery_phone_mobile":"+49 171 1234567"}'
# The HMAC is calculated over the exact request body that is sent
HMAC=$(printf '%s' "$PAYLOAD" | openssl dgst -sha256 -hmac "$API_SECRET" -binary | base64)
curl -X POST "https://www.billware.de/api/v1" \
-H "X-Bw-Hmac: $API_APPID:$HMAC" \
-H "X-Bw-Method: address.create" \
-H "Content-Type: application/json" \
-d "$PAYLOAD"
<?php
// Get your API credentials from your billware customer area
$apiAppId = 'your-app-id';
$apiSecret = 'your-api-secret';
$payload = json_encode([
'customer_ident' => '46yq1898qmohrz57',
'delivery_title' => 0,
'delivery_firstname' => 'Max',
'delivery_lastname' => 'Mustermann',
'delivery_company' => 'Muster GmbH',
'delivery_street' => 'Lieferweg 5',
'delivery_street2' => 'Etage 3',
'delivery_zipcode' => '54321',
'delivery_city' => 'Lieferstadt',
'delivery_country' => 'de',
'delivery_phone' => '+49 987 6543210',
'delivery_phone_mobile' => '+49 171 1234567',
]);
// The HMAC is calculated over the exact request body that is sent
$hmac = base64_encode(hash_hmac('sha256', $payload, $apiSecret, true));
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => 'https://www.billware.de/api/v1',
CURLOPT_POST => true,
CURLOPT_POSTFIELDS => $payload,
CURLOPT_RETURNTRANSFER => true,
CURLOPT_HTTPHEADER => [
'X-Bw-Hmac: '.$apiAppId.':'.$hmac,
'X-Bw-Method: address.create',
'Content-Type: application/json',
],
]);
$response = curl_exec($curl);
curl_close($curl);
print_r(json_decode($response, true));
import crypto from 'node:crypto';
// Get your API credentials from your billware customer area
const apiAppId = 'your-app-id';
const apiSecret = 'your-api-secret';
const payload = JSON.stringify({
"customer_ident": "46yq1898qmohrz57",
"delivery_title": 0,
"delivery_firstname": "Max",
"delivery_lastname": "Mustermann",
"delivery_company": "Muster GmbH",
"delivery_street": "Lieferweg 5",
"delivery_street2": "Etage 3",
"delivery_zipcode": "54321",
"delivery_city": "Lieferstadt",
"delivery_country": "de",
"delivery_phone": "+49 987 6543210",
"delivery_phone_mobile": "+49 171 1234567"
});
// The HMAC is calculated over the exact request body that is sent
const hmac = crypto.createHmac('sha256', apiSecret).update(payload).digest('base64');
const response = await fetch('https://www.billware.de/api/v1', {
method: 'POST',
headers: {
'X-Bw-Hmac': `${apiAppId}:${hmac}`,
'X-Bw-Method': 'address.create',
'Content-Type': 'application/json'
},
body: payload
});
console.log(await response.json());
import base64
import hashlib
import hmac
import json
import requests
# Get your API credentials from your billware customer area
api_appid = "your-app-id"
api_secret = "your-api-secret"
payload = json.dumps({
"customer_ident": "46yq1898qmohrz57",
"delivery_title": 0,
"delivery_firstname": "Max",
"delivery_lastname": "Mustermann",
"delivery_company": "Muster GmbH",
"delivery_street": "Lieferweg 5",
"delivery_street2": "Etage 3",
"delivery_zipcode": "54321",
"delivery_city": "Lieferstadt",
"delivery_country": "de",
"delivery_phone": "+49 987 6543210",
"delivery_phone_mobile": "+49 171 1234567",
})
# The HMAC is calculated over the exact request body that is sent
signature = base64.b64encode(
hmac.new(api_secret.encode(), payload.encode(), hashlib.sha256).digest()
).decode()
response = requests.post(
"https://www.billware.de/api/v1",
data=payload,
headers={
"X-Bw-Hmac": f"{api_appid}:{signature}",
"X-Bw-Method": "address.create",
"Content-Type": "application/json",
},
)
print(response.json())
using System.Net.Http;
using System.Security.Cryptography;
using System.Text;
using System.Text.Json;
// Get your API credentials from your billware customer area
const string apiAppId = "your-app-id";
const string apiSecret = "your-api-secret";
var payload = JsonSerializer.Serialize(new
{
customer_ident = "46yq1898qmohrz57",
delivery_title = 0,
delivery_firstname = "Max",
delivery_lastname = "Mustermann",
delivery_company = "Muster GmbH",
delivery_street = "Lieferweg 5",
delivery_street2 = "Etage 3",
delivery_zipcode = "54321",
delivery_city = "Lieferstadt",
delivery_country = "de",
delivery_phone = "+49 987 6543210",
delivery_phone_mobile = "+49 171 1234567"
});
// The HMAC is calculated over the exact request body that is sent
using var hmac = new HMACSHA256(Encoding.UTF8.GetBytes(apiSecret));
var signature = Convert.ToBase64String(hmac.ComputeHash(Encoding.UTF8.GetBytes(payload)));
using var client = new HttpClient();
var request = new HttpRequestMessage(HttpMethod.Post, "https://www.billware.de/api/v1")
{
Content = new StringContent(payload, Encoding.UTF8, "application/json")
};
request.Headers.Add("X-Bw-Hmac", $"{apiAppId}:{signature}");
request.Headers.Add("X-Bw-Method", "address.create");
var response = await client.SendAsync(request);
Console.WriteLine(await response.Content.ReadAsStringAsync());
# Get your API credentials from your billware customer area
API_APPID="your-app-id"
API_SECRET="your-api-secret"
PAYLOAD='{"address_ident":"61636lu6Et7324W8"}'
# The HMAC is calculated over the exact request body that is sent
HMAC=$(printf '%s' "$PAYLOAD" | openssl dgst -sha256 -hmac "$API_SECRET" -binary | base64)
curl -X POST "https://www.billware.de/api/v1" \
-H "X-Bw-Hmac: $API_APPID:$HMAC" \
-H "X-Bw-Method: address.exists" \
-H "Content-Type: application/json" \
-d "$PAYLOAD"
<?php
// Get your API credentials from your billware customer area
$apiAppId = 'your-app-id';
$apiSecret = 'your-api-secret';
$payload = json_encode([
'address_ident' => '61636lu6Et7324W8',
]);
// The HMAC is calculated over the exact request body that is sent
$hmac = base64_encode(hash_hmac('sha256', $payload, $apiSecret, true));
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => 'https://www.billware.de/api/v1',
CURLOPT_POST => true,
CURLOPT_POSTFIELDS => $payload,
CURLOPT_RETURNTRANSFER => true,
CURLOPT_HTTPHEADER => [
'X-Bw-Hmac: '.$apiAppId.':'.$hmac,
'X-Bw-Method: address.exists',
'Content-Type: application/json',
],
]);
$response = curl_exec($curl);
curl_close($curl);
print_r(json_decode($response, true));
import crypto from 'node:crypto';
// Get your API credentials from your billware customer area
const apiAppId = 'your-app-id';
const apiSecret = 'your-api-secret';
const payload = JSON.stringify({
"address_ident": "61636lu6Et7324W8"
});
// The HMAC is calculated over the exact request body that is sent
const hmac = crypto.createHmac('sha256', apiSecret).update(payload).digest('base64');
const response = await fetch('https://www.billware.de/api/v1', {
method: 'POST',
headers: {
'X-Bw-Hmac': `${apiAppId}:${hmac}`,
'X-Bw-Method': 'address.exists',
'Content-Type': 'application/json'
},
body: payload
});
console.log(await response.json());
import base64
import hashlib
import hmac
import json
import requests
# Get your API credentials from your billware customer area
api_appid = "your-app-id"
api_secret = "your-api-secret"
payload = json.dumps({
"address_ident": "61636lu6Et7324W8",
})
# The HMAC is calculated over the exact request body that is sent
signature = base64.b64encode(
hmac.new(api_secret.encode(), payload.encode(), hashlib.sha256).digest()
).decode()
response = requests.post(
"https://www.billware.de/api/v1",
data=payload,
headers={
"X-Bw-Hmac": f"{api_appid}:{signature}",
"X-Bw-Method": "address.exists",
"Content-Type": "application/json",
},
)
print(response.json())
using System.Net.Http;
using System.Security.Cryptography;
using System.Text;
using System.Text.Json;
// Get your API credentials from your billware customer area
const string apiAppId = "your-app-id";
const string apiSecret = "your-api-secret";
var payload = JsonSerializer.Serialize(new
{
address_ident = "61636lu6Et7324W8"
});
// The HMAC is calculated over the exact request body that is sent
using var hmac = new HMACSHA256(Encoding.UTF8.GetBytes(apiSecret));
var signature = Convert.ToBase64String(hmac.ComputeHash(Encoding.UTF8.GetBytes(payload)));
using var client = new HttpClient();
var request = new HttpRequestMessage(HttpMethod.Post, "https://www.billware.de/api/v1")
{
Content = new StringContent(payload, Encoding.UTF8, "application/json")
};
request.Headers.Add("X-Bw-Hmac", $"{apiAppId}:{signature}");
request.Headers.Add("X-Bw-Method", "address.exists");
var response = await client.SendAsync(request);
Console.WriteLine(await response.Content.ReadAsStringAsync());
Beispielantworten
// SUCCESS
{
"response": true,
"data": {
"address_ident": "61636lu6Et7324W8"
},
"method": "address.exists",
"message": "address does exist"
}
// ERROR – the request itself was fine, the address is unknown
{
"response": false,
"data": {
"address_ident": "61636lu6Et7324W8"
},
"method": "address.exists",
"message": "address does not exist"
}